*******************************************************************************
*                         680xx Grundprogramm sincos                          *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2008 Jens Mewes                                 *
*                                 Rev 7.10                                    *
*                                01.01.2008                                   *
*                         Sinus und Cosinus Routinen                          *
*******************************************************************************


* Unterprogramme fr sin/cos

adj360:                         * Bereich 0..359 wandeln
 tst d0
 bmi.s adj1                     * Negativ, dann addieren
adjlp:
 cmp #360,d0
 bmi.s adjfin                   * Kleiner 360, dann OK
 sub #360,d0                    * Sonst subtrahieren
bra.s adjlp
adj1:
 add #360,d0                    * So lange addieren, bis grer 0
 bmi.s adj1
adjfin:
rts

cos:                            * Cosinus berechnen
 add #90,d0
sin:                            * Sinus berechnen
 bsr.s adj360                   * 0..359 wandeln
 add d0,d0                      * Mal zwei fr Tabellenverwaltung
 cmp #540,d0
 bpl.s sin3
 cmp #360,d0
 bpl.s sin2
 cmp #180,d0
 bpl.s sin1
sin0:                           * 0 <= X < 90
 move sintab(pc,d0),d0
rts
sin1:                           * 90 <= X < 180
 sub #360,d0
 neg d0
 move sintab(pc,d0),d0
rts
sin2:                           * 180 <= X < 270
 sub #360,d0
 move sintab(pc,d0),d0
 neg d0
rts
sin3:                           * 270 <= X < 360
 sub #720,d0
 neg d0
 move sintab(pc,d0),d0
 neg d0
rts

sintab:
 dc.w 0,4,9,13,18,22,27,31,36,40,44,49,53,58,62,66,71,75,79,83,88,92,96,100,104
 dc.w 108,112,116,120,124,128,132,136,139,143,147,150,154,158,161,165,168
 dc.w 171,175,178,181,184,187,190,193,196,199,202,205,207,210,212,215,217,219
 dc.w 222,224,226,228,230,232,234,236,237,239,241,242,243,245,246,247,248,249
 dc.w 250,251,252,253,254,254,255,255,255,256,256,256,256
