*******************************************************************************
*                        680xx Grundprogramm aendere                          *
*                         (C) 1990 Ralph Dombrowski                           *
*                             2008 Jens Mewes                                 *
*                                 Rev 7.10                                    *
*                                01.01.2008                                   *
*                             Menpunkt ndern                                *
*******************************************************************************


aendere:                        * Speicherstelle(n) ndern
 lea txta1(pc),a0
 bsr headaclr                   * berschrift
aend0:
 bsr getadr                     * Adresse Ram
 bcs carset                     * Fehler ist Abbruch
 movea.l d0,a4                  * Adresse merken
aend1:
 lea txta2(pc),a0
 moveq #$22,d0
 moveq #10,d1
 moveq #25,d2
 bsr textprint                  * Befehle
aend2:
 lea ausbuf(a5),a0
 movea.l a0,a1                  * Ausbuf-Adresse merken
 move.l a4,d0
 bsr print8x                    * Adresse ausgeben
 move #': ',(a0)+
 movea.l a0,a2
 movea.l a4,a3
 moveq #5-1,d7                  * 5 Werte
aend3a:
 move.b (a3)+,d0
 bsr print2x                    * Hexadezimal
 move #'  ',(a0)+
dbra d7,aend3a
 clr.b (a0)
 movea.l a1,a0
 moveq #$22,d0
 moveq #20,d1
 move #160,d2
 lea ausbuf(a5),a0
 bsr textaus                    * Hex-Ausgabe
 movea.l a2,a0
 movea.l a4,a3
 moveq #5-1,d7                  * 5 Werte
aend3b:
 move.b (a3)+,d0                * Bit 8-15 sind 0 !!
 move.l #'    ',(a0)            * Leerraum fr verschiedene Anzahl Zeichen
 move.l a0,-(a7)                * a0 retten
 bsr print4d                    * Dezimal
 move.b #' ',(a0)               * Endekennung lschen
 movea.l (a7)+,a0               * a0 zurck
 addq.l #4,a0
dbra d7,aend3b
 clr.b (a0)
 movea.l a1,a0
 moveq #$22,d0
 move #140,d2
 bsr textaus                    * Dez-Ausgabe
 movea.l a4,a3
 moveq #5-1,d7                  * 5 Werte
aend3c:
 move.b (a3)+,d0
 bsr putascii                   * ASCII
 move.b d0,(a2)+
 move.b #' ',(a2)+
 move #'  ',(a2)+
dbra d7,aend3c
 clr.b (a2)
 movea.l a1,a0
 moveq #$22,d0
 moveq #120,d2
 bsr textaus                    * ASCII-Ausgabe
 lea einbuf(a5),a0
 clr.b (a0)
 move.l a4,d0                   * Adresse
 btst.b #0,d0
 bne.s aend4                    * Ungerade Adresse, dann kein DIS-Assembler
 bsr trapdisass                 * DIS-Assemblieren
aend4:
 moveq #82-1,d0
aend5:
 move.b (a0)+,(a1)+             * Maximal 82 Zeichen bertragen
dbeq d0,aend5
 subq.l #1,a1                   * Zurck
 tst d0
 bmi.s aend7                    * Wenn Zeile voll, dann weiter
aend6:
 move.b #' ',(a1)+              * Rest mit Leerzeichen fllen
dbra d0,aend6
aend7:
 clr.b (a1)                     * Ende markieren
 lea ausbuf(a5),a0
 moveq #$11,d0
 moveq #20,d1
 move #105,d2
 bsr textaus                    * Text ausgeben
aend8:
 lea einbuf(a5),a0
 moveq #$22,d0
 moveq #20,d1
 moveq #70,d2
 moveq #35,d3                   * Maximal 35 Zeichen
 bsr textein                    * Befehlseingabe
 bcs carset                     * Abbruch
 tst d4                         * Wenn mindestens 1 Zeichen, dann weiter
 bne.s aend9
 addq.l #1,a4                   * Sonst Adresse+1
bra aend2
aend9:
 cmp #1,d4                      * Mehr als 1 Zeichen, dann weiter
 bne.s aend13
 move.b -(a0),d0                * Das Zeichen holen
 cmp.b #'-',d0                  * '-' = Adresse-1
 bne.s aend10
 subq.l #1,a4
 bra aend2
aend10:
 bsr bucheck
 cmp.b #'R',d0                  * 'R' = neue Adresse
 beq aend0
 cmp.b #'D',d0                  * 'D' = Zum Dump umschalten
 bne.s aend11
 lea txta1(pc),a0
 bsr headaclr                   * Alte berschrift
 move.b #1,wrtpage(a5)
 bsr aktpage                    * Auf beiden Seiten ausgeben
 bsr headaus
 move.l a4,d0
 bsr spdump                     * Dump aufrufen
 bsr speich2                    * Befehle fr Dump
 lea txta1(pc),a0
 bsr headaclr                   * berschrift neu
 move.l a4,d0
 and.b #$f0,d0
 sub.l a3,d0
 suba.l d0,a4                   * Neue Adresse berechnet
bra aend1
aend11:
 cmp.b #'F',d0                  * 'F' = Fllen
 bne.s aend12
 bsr fillspei
bra aend2
aend12:
 cmp.b #'S',d0                  * 'S' = Suchen
 bne.s aend13
 bsr suchwert
 bcs aend8                      * Fehler, nicht gefunden
bra aend2                       * OK, gefunden
aend13:
 cmp.b #$1b,d0                  * <ESC> = Ende
 beq.s *+8
 cmp.b #'M',d0                  * 'M' = Ende
 bne.s aend14
rts
aend14:                         * Wert berechnen und ins Ram
 lea einbuf(a5),a0
 bsr igbn
 cmp.b #$27,(a0)
 bne.s aend15
 bsr.s getstring                * Ist String eingegeben worden ?
 bcs aend8                      * Fehler
bra.s aend16                    * OK, String ausgeben
aend15:
 bsr zuweis                     * Symboldefinition ist erlaubt
 bcc aend8
 bsr wertmfeh                   * Keine Definition, dann Wert ausrechnen
 bcs aend8
 bsr putwert                    * Wert in ausbuf ablegen und d0 vorbereiten
aend16:
 move.l d0,d1                   * Anzahl der Bytes
 bsr fillsp0                    * Speicher fllen
bra aend2                       * Wiederholen

